package uy.edu.fing.chesstrack.modulovision.imgproc;

import org.opencv.core.Mat;
import org.opencv.imgproc.Imgproc;
import org.opencv.video.BackgroundSubtractorMOG2;


public class SustraccionDeFondo implements ImgProcInterface  {
	private  Mat fMaskMOG = null;
	private final BackgroundSubtractorMOG2 pMOG;
	private static final String TAG = "CHESSTRACK::SustraccionDeFondo";
	public SustraccionDeFondo(){
		pMOG = new BackgroundSubtractorMOG2();
		//fMaskMOG = new Mat();
	}

	@Override
	public Mat procesarImagen(Mat inputFrame) {
		Imgproc.cvtColor(inputFrame, inputFrame, Imgproc.COLOR_RGBA2RGB);

		fMaskMOG = new Mat(inputFrame.size(),inputFrame.channels());
		pMOG.apply(inputFrame, fMaskMOG);
		//Mat frame = inputFrame.submat(Calibracion.getInstance().getRectPOI());

		//fMaskMOG = new Mat(frame.size(),frame.channels());
		//pMOG.apply(frame, fMaskMOG);

		//Imgproc.resize(inputFrame, frame, frame.size());
		//Log.i(TAG, "Size frame= " + frame.size());
		//Log.i(TAG, "Size fMaskMOG= " + fMaskMOG.size());

		//Rect aux = Calibracion.getInstance().getRectPOI();


		//frame.copyTo(frame,fMaskMOG);

		//Mat subMat = inputFrame.submat(0,frame.rows(),0,frame.cols());
		//frame.copyTo(subMat);
		//Mat frame = new Mat();
		//inputFrame.copyTo(frame,fMaskMOG);
		return fMaskMOG;
	}

}
